diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdcore/pc_core.h PDFlib-Lite-7.0.4/libs/pdcore/pc_core.h
--- PDFlib-Lite-7.0.4.bak/libs/pdcore/pc_core.h	2009-03-18 15:10:05.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdcore/pc_core.h	2009-06-08 17:57:27.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: pc_core.h,v 1.216.2.19 2008/08/25 15:32:20 kurt Exp $
+/* $Id: pc_core.h,v 1.216.2.21 2009/04/29 12:24:53 york Exp $
  *
  * PDFlib core services:
  * - memory management
@@ -65,13 +65,16 @@
 */
 #if	defined(_LARGEFILE_SOURCE)
     #if defined(WIN32)
-	typedef __int64	pdc_off_t;
+	typedef __int64			pdc_off_t;
+	typedef unsigned __int64	pdc_uoff_t;
     #else
 #include <sys/types.h>
-	typedef off_t	pdc_off_t;
+	typedef off_t			pdc_off_t;
+	typedef unsigned long long	pdc_uoff_t;
     #endif
 #else
-	typedef long	pdc_off_t;
+	typedef long			pdc_off_t;
+	typedef unsigned long		pdc_uoff_t;
 #endif
 
 /* use this one for casts from "off_t" to "long" - so we can "grep"
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdcore/pc_prefix.h PDFlib-Lite-7.0.4/libs/pdcore/pc_prefix.h
--- PDFlib-Lite-7.0.4.bak/libs/pdcore/pc_prefix.h	2009-03-18 15:10:05.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdcore/pc_prefix.h	2009-06-08 17:57:28.000000000 +0200
@@ -6,7 +6,7 @@
  |          Proprietary source code -- do not redistribute!                  |
  *---------------------------------------------------------------------------*/
 
-/* $Id: pc_prefix.h,v 1.31.2.6 2007/12/06 14:16:38 york Exp $
+/* $Id: pc_prefix.h,v 1.31.2.7 2009/04/29 19:16:44 serge Exp $
  *
  * PDCORE: unique renaming of function names shared by different applications
  */
@@ -15,3 +15,4 @@
 #define PC_PREFIX_H
 
 #endif  /* PC_PREFIX_H */
+
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdcore/pc_resource.c PDFlib-Lite-7.0.4/libs/pdcore/pc_resource.c
--- PDFlib-Lite-7.0.4.bak/libs/pdcore/pc_resource.c	2009-03-18 15:10:05.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdcore/pc_resource.c	2009-06-08 17:57:28.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: pc_resource.c,v 1.61.2.44 2009/03/16 14:01:12 kurt Exp $
+/* $Id: pc_resource.c,v 1.61.2.48 2009/04/01 20:48:29 kurt Exp $
  *
  * Resource routines
  *
@@ -28,6 +28,8 @@
 #if defined(WIN32)
 #define WIN32_LEAN_AND_MEAN
 #include <windows.h>
+#else
+#include <unistd.h>
 #endif
 
 
@@ -314,7 +316,10 @@
 
             np = pdc_split_stringlist(pdc, buffer, ";", 0, &pathlist);
             for (ip = 0; ip < np; ip++)
+            {
+                /* TODO: we should only accessible directories */
                 pdc_add_resource(pdc, "SearchPath", pathlist[ip], "");
+            }
             pdc_cleanup_stringlist(pdc, pathlist);
         }
 
@@ -335,11 +340,15 @@
         else
              strcpy(tmpname, rootdirectories[il]);
 
-        for (ip = 0; defsearchpathlist[ip] != NULL; ip++)
+        /* we allow only accessible root directories */
+        if (access(tmpname, X_OK) != -1)
         {
-            sprintf(buffer, defsearchpathlist[ip],
-                    tmpname, prodname, prodversion);
-            pdc_add_resource(pdc, "SearchPath", buffer, "");
+            for (ip = 0; defsearchpathlist[ip] != NULL; ip++)
+            {
+                sprintf(buffer, defsearchpathlist[ip],
+                        tmpname, prodname, prodversion);
+                pdc_add_resource(pdc, "SearchPath", buffer, "");
+            }
         }
     }
 #endif /* !WIN32 && !AS400 && !MVS */
@@ -1318,16 +1327,20 @@
     PDC_OPT_TERMINATE
 };
 
+#define PDC_SEPARSTR_LEN 80
+
 static const char *separstr =
-    "[ --------------------------------------------------------- ]\n";
+    "[---------------------------------------"
+    "---------------------------------------]\n";
 
 void
 pdc_set_logg_options(pdc_core *pdc, const char *optlist)
 {
     pdc_loggdef *logg = pdc_get_logg(pdc);
     pdc_resopt *resopts = NULL;
-    char **strlist, *keyword;
+    char **strlist;
     char filename[PDC_FILENAMELEN+1];
+    const char *keyword;
     pdc_bool sare = pdc_false;
     pdc_bool enable = pdc_true;
     pdc_bool remfile = pdc_false;
@@ -1506,7 +1519,9 @@
         logg->enabled = enable;
         if (logg->enabled && logg->header && pdc->prodname != NULL)
         {
-            char binding[64];
+            char binding[64], buf[256], *bp;
+
+            pdc_logg(pdc, separstr);
 
             pdc_localtime(&ltime);
             binding[0] = 0;
@@ -1515,17 +1530,38 @@
                 strcat(binding, pdc->binding);
                 strcat(binding, " binding ");
             }
-            pdc_logg(pdc, separstr);
-            pdc_logg(pdc, "[ %s %s  %son %s (%s) ",
-                      pdc->prodname, pdc->version, binding,
-                      PDF_PLATFORM, PDC_ISBIGENDIAN ? "be" : "le");
-            pdc_logg(pdc, "%04d-%02d-%02d %02d:%02d:%02d ]\n",
-                ltime.year + 1900, ltime.month + 1, ltime.mday,
-                ltime.hour, ltime.minute, ltime.second);
+
+            sprintf(buf, "[ %s %s  %son %s (%s) %04d-%02d-%02d %02d:%02d:%02d",
+                    pdc->prodname, pdc->version, binding,
+                    PDF_PLATFORM, PDC_ISBIGENDIAN ? "be" : "le",
+                    ltime.year + 1900, ltime.month + 1, ltime.mday,
+                    ltime.hour, ltime.minute, ltime.second);
+
+            i = MAX(PDC_SEPARSTR_LEN - (int) strlen(buf) - 1, 1);
+            pdc_logg(pdc, "%s%*s]\n", buf, i, " ");
+
+            bp = buf;
+            bp += sprintf(buf, "[ Classes:");
+            for (pclass = 0; pclass < trc_numclasses; pclass++)
+            {
+                level = logg->classlist[logg->sri][pclass];
+                if (level)
+                {
+                    keyword = pdc_get_keyword(pclass, pdf_protoclass_keylist);
+                    bp += sprintf(bp, " %s=%d", keyword, level);
+                }
+            }
+            i = MAX(PDC_SEPARSTR_LEN - (int) strlen(buf) - 1, 1);
+            pdc_logg(pdc, "%s%*s]\n", buf, i, " ");
 
             if (logg->classapi)
-                pdc_logg(pdc, "[ Use  %%s/\\[[^]]*\\]//g  and  %%s/)$/);"
-                               "/  in vi to compile it ]\n");
+            {
+                strcpy(buf, "[ Use  %%s/\\[[^]]*\\]//g  and  %%s/)$/);"
+                             "/  in vi to compile it");
+                i = MAX(PDC_SEPARSTR_LEN - (int) strlen(buf) - 1, 1);
+                pdc_logg(pdc, "%s%*s]\n", buf, i, " ");
+            }
+
             pdc_logg(pdc, separstr);
         }
     }
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdcore/pc_resource.h PDFlib-Lite-7.0.4/libs/pdcore/pc_resource.h
--- PDFlib-Lite-7.0.4.bak/libs/pdcore/pc_resource.h	2009-03-18 15:10:05.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdcore/pc_resource.h	2009-06-08 17:57:28.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: pc_resource.h,v 1.25.2.10 2009/03/13 13:59:08 kurt Exp $
+/* $Id: pc_resource.h,v 1.25.2.11 2009/03/31 19:26:17 kurt Exp $
  *
  * Resource routines
  *
@@ -76,7 +76,9 @@
     trc_warning,        /* logging of disabled warnings */
     trc_wordfinder,     /* word finder logging */
     trc_xmp,            /* xmp logging */
-    trc_zones           /* zones logging */
+    trc_zones,          /* zones logging */
+
+    trc_numclasses      /* number of classes */
 }
 pdc_logg_class;
 
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdcore/pc_scope.c PDFlib-Lite-7.0.4/libs/pdcore/pc_scope.c
--- PDFlib-Lite-7.0.4.bak/libs/pdcore/pc_scope.c	2009-03-18 15:10:05.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdcore/pc_scope.c	2009-06-08 17:57:28.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: pc_scope.c,v 1.110.2.41 2009/03/12 15:23:46 rjs Exp $
+/* $Id: pc_scope.c,v 1.110.2.42 2009/05/11 14:44:19 rjs Exp $
  *
  * Scoping routines and macros
  *
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdcore/pc_unicode.c PDFlib-Lite-7.0.4/libs/pdcore/pc_unicode.c
--- PDFlib-Lite-7.0.4.bak/libs/pdcore/pc_unicode.c	2009-03-18 15:10:06.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdcore/pc_unicode.c	2009-06-08 17:57:28.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: pc_unicode.c,v 1.179.2.30 2009/03/04 17:10:29 kurt Exp $
+/* $Id: pc_unicode.c,v 1.179.2.32 2009/04/01 19:33:27 kurt Exp $
  *
  * PDFlib Unicode converting routines
  *
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdcore/pc_util.c PDFlib-Lite-7.0.4/libs/pdcore/pc_util.c
--- PDFlib-Lite-7.0.4.bak/libs/pdcore/pc_util.c	2009-03-18 15:10:06.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdcore/pc_util.c	2009-06-08 17:57:28.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: pc_util.c,v 1.209.2.60 2009/03/10 09:54:30 rjs Exp $
+/* $Id: pc_util.c,v 1.209.2.64 2009/04/29 19:16:44 serge Exp $
  *
  * PDFlib various utility routines
  *
@@ -1479,6 +1479,8 @@
     return retval;
 }
 
+/* return value: length of new string. -1: error
+*/
 int
 pdc_subst_backslash(pdc_core *pdc, pdc_byte *str, int len,
                     pdc_encodingvector *ev, pdc_text_format textformat,
@@ -1612,7 +1614,7 @@
                 if (verbose)
                     pdc_error(pdc, -1, 0, 0, 0, 0);
 
-                return 0;
+                return -1;
             }
         }
 
@@ -1639,7 +1641,7 @@
     if (verbose)
         pdc_error(pdc, -1, 0, 0, 0, 0);
 
-    return 0;
+    return -1;
 }
 
 
@@ -1910,6 +1912,23 @@
     return pdc_true;
 }
 
+
+pdc_bool
+pdc_str2integer_ext(pdc_core *pdc, const char *string, int len,
+                    int dupflags, int flags, void *o_iz)
+{
+    static const char fn[] = "pdc_str2integer_ext";
+    char *dupstr;
+    pdc_bool retval;
+
+    dupstr = pdc_strdup_ext(pdc, string, dupflags, fn);
+    dupstr[len] = 0;
+    retval = pdc_str2integer(dupstr, flags, o_iz);
+    pdc_free(pdc, dupstr);
+    return retval;
+}
+
+
 static const char digits[] = "0123456789ABCDEF";
 
 static char *
@@ -1964,9 +1983,9 @@
 
 
 static char *
-pdc_ulong2a(
+pdc_uoff_t2a(
     char *	buf,
-    pdc_off_t	n,
+    pdc_uoff_t	n,
     int		width,
     char	pad,
     int		base,
@@ -1975,21 +1994,6 @@
     char        aux[100];
     int         k, i = sizeof aux;
     char *      dest = buf;
-    pdc_bool    sign;
-
-    if (n < 0)
-    {
-        --width;
-        sign = pdc_true;
-        aux[--i] = digits[- (n % base)];
-        n = n / -base;
-    }
-    else
-    {
-        sign = pdc_false;
-        aux[--i] = digits[n % base];
-        n = n / base;
-    }
 
     while (0 < n)
     {
@@ -2005,9 +2009,6 @@
 	    *(dest++) = pad;
     }
 
-    if (sign)
-        *(dest++) = '-';
-
     memcpy(dest, &aux[i], sizeof aux - i);
     dest += sizeof aux - i;
 
@@ -2018,7 +2019,7 @@
     }
 
     return dest;
-} /* pdc_ulong2a */
+} /* pdc_uoff_t2a */
 
 
 static char *
@@ -2432,8 +2433,8 @@
         {
             case 'x':
             case 'X':
-                dest = pdc_ulong2a(
-                        dest, (pdc_off_t) va_arg(args, pdc_uint),
+                dest = pdc_uoff_t2a(
+                        dest, (pdc_uoff_t) va_arg(args, pdc_uint),
                         width, pad, 16, left_justify);
                 break;
 
@@ -2447,8 +2448,8 @@
                 break;
 
             case 'u':
-                dest = pdc_ulong2a(
-                        dest, (pdc_off_t) va_arg(args, pdc_ulong),
+                dest = pdc_uoff_t2a(
+                        dest, (pdc_uoff_t) va_arg(args, pdc_uint),
                         width, pad, 10, left_justify);
                 break;
 
@@ -2467,6 +2468,7 @@
             case 'l':
             {
                 pdc_off_t	n = 0;
+                pdc_uoff_t	u = 0;
 		pdc_bool	ll = pdc_false;
 
                 if (*(++format) == 'l')
@@ -2478,9 +2480,9 @@
 		if (strchr("xXu", *format))
 		{
 		    if (ll)
-			n = va_arg(args, pdc_off_t);
+			u = va_arg(args, pdc_uoff_t);
 		    else
-			n = va_arg(args, pdc_ulong);
+			u = va_arg(args, pdc_ulong);
 		}
 		else if (*format == 'd')
 		{
@@ -2502,8 +2504,8 @@
                 {
                     case 'x':
                     case 'X':
-                        dest = pdc_ulong2a(
-				    dest, n, width, pad, 16, left_justify);
+                        dest = pdc_uoff_t2a(
+				    dest, u, width, pad, 16, left_justify);
                         break;
 
                     case 'd':
@@ -2512,8 +2514,8 @@
                         break;
 
                     case 'u':
-                        dest = pdc_ulong2a(
-				    dest, n, width, pad, 10, left_justify);
+                        dest = pdc_uoff_t2a(
+				    dest, u, width, pad, 10, left_justify);
                         break;
 
                     default:
@@ -3127,3 +3129,4 @@
 {
     pdc->last_rand = seed;
 } /* pdc_srand */
+
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdcore/pc_util.h PDFlib-Lite-7.0.4/libs/pdcore/pc_util.h
--- PDFlib-Lite-7.0.4.bak/libs/pdcore/pc_util.h	2009-03-18 15:10:06.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdcore/pc_util.h	2009-06-08 17:57:28.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: pc_util.h,v 1.107.2.34 2008/09/08 12:58:41 kurt Exp $
+/* $Id: pc_util.h,v 1.107.2.35 2009/04/29 19:16:44 serge Exp $
  *
  * Declaration of various utility routines
  *
@@ -248,6 +248,8 @@
 
 pdc_bool pdc_str2double(const char *string, double *o_dz);
 pdc_bool pdc_str2integer(const char *string, int flags, void *o_iz);
+pdc_bool pdc_str2integer_ext(pdc_core *pdc, const char *string, int len,
+                             int dupflags, int flags, void *o_iz);
 
 int pdc_vfprintf(pdc_core *pdc, pdc_bool pdfconf, FILE *fp,
                 const char *format, va_list args);
@@ -284,3 +286,4 @@
 void	pdc_srand(pdc_core *pdc, pdc_uint seed);
 
 #endif	/* PC_UTIL_H */
+
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdcore/pc_xmp.c PDFlib-Lite-7.0.4/libs/pdcore/pc_xmp.c
--- PDFlib-Lite-7.0.4.bak/libs/pdcore/pc_xmp.c	2009-03-18 15:10:06.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdcore/pc_xmp.c	2009-06-08 17:57:28.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: pc_xmp.c,v 1.38.2.169 2009/03/04 00:05:46 serge Exp $
+/* $Id: pc_xmp.c,v 1.38.2.171 2009/04/29 19:16:44 serge Exp $
  *
  * The core XMP support.
  *
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdflib/p_block.c PDFlib-Lite-7.0.4/libs/pdflib/p_block.c
--- PDFlib-Lite-7.0.4.bak/libs/pdflib/p_block.c	2009-03-18 15:10:06.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdflib/p_block.c	2009-06-08 17:57:28.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_block.c,v 1.169.2.20 2009/02/16 12:31:39 tm Exp $
+/* $Id: p_block.c,v 1.169.2.22 2009/04/09 09:03:16 kurt Exp $
  *
  * Block processing routines (require the PDI library)
  *
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdflib/p_color.c PDFlib-Lite-7.0.4/libs/pdflib/p_color.c
--- PDFlib-Lite-7.0.4.bak/libs/pdflib/p_color.c	2009-03-18 15:10:06.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdflib/p_color.c	2009-06-08 17:57:28.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_color.c,v 1.217.2.11 2008/08/01 12:52:08 tm Exp $
+/* $Id: p_color.c,v 1.217.2.12 2009/06/04 11:22:04 york Exp $
  *
  * PDFlib color routines
  *
@@ -162,10 +162,9 @@
 static void
 pdf_write_color_values(PDF *p, pdf_color *color, pdf_drawmode drawmode)
 {
-    static const char *fn = "pdf_write_color_values";
+    static const char	fn[] = "pdf_write_color_values";
+
     pdf_colorspace *	cs = &p->colorspaces[color->cs];
-    int			cs_bias = p->curr_ppt->cs_bias;
-    int			pt_bias = p->curr_ppt->pt_bias;
 
     switch (cs->type)
     {
@@ -221,11 +220,11 @@
 		{
                     pdf_color *fillcolor = pdf_get_cstate(p, pdf_fill);
 
-		    pdc_printf(p->out, "/C%d cs ", cs_bias + color->cs);
+		    pdc_printf(p->out, "/C%d cs ", color->cs);
                     pdf_write_color_values(p, fillcolor, pdf_none);
 		}
 
-		pdc_printf(p->out, "/P%d scn\n", pt_bias + color->val.pattern);
+		pdc_printf(p->out, "/P%d scn\n", color->val.pattern);
 	    }
 	    else if (drawmode == pdf_stroke)
 	    {
@@ -237,11 +236,11 @@
 		{
                     pdf_color *strokecolor = pdf_get_cstate(p, pdf_stroke);
 
-		    pdc_printf(p->out, "/C%d CS ", cs_bias + color->cs);
+		    pdc_printf(p->out, "/C%d CS ", color->cs);
                     pdf_write_color_values(p, strokecolor, pdf_none);
 		}
 
-		pdc_printf(p->out, "/P%d SCN\n", pt_bias + color->val.pattern);
+		pdc_printf(p->out, "/P%d SCN\n", color->val.pattern);
 	    }
 
 	    p->pattern[color->val.pattern].used_on_current_page = pdc_true;
@@ -509,13 +508,12 @@
 pdf_write_page_colorspaces(PDF *p)
 {
     int i, total = 0;
-    int bias = p->curr_ppt->cs_bias;
 
     for (i = 0; i < p->colorspaces_number; i++)
 	if (p->colorspaces[i].used_on_current_page)
 	    total++;
 
-    if (total > 0 || bias
+    if (total > 0
        )
     {
 	pdc_puts(p->out, "/ColorSpace");
@@ -534,7 +532,7 @@
 		    /* don't write simple color spaces as resource */
 		    if (!PDF_SIMPLE_COLORSPACE(cs))
 		    {
-			pdc_printf(p->out, "/C%d", bias + i);
+			pdc_printf(p->out, "/C%d", i);
 			pdc_objref(p->out, "", cs->obj_id);
 		    }
 		}
@@ -542,7 +540,6 @@
 	}
 
 
-	if (!bias)
 	    pdc_end_dict(p->out);		/* color space names */
     }
 } /* pdf_write_page_colorspaces */
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdflib/p_defopt.h PDFlib-Lite-7.0.4/libs/pdflib/p_defopt.h
--- PDFlib-Lite-7.0.4.bak/libs/pdflib/p_defopt.h	2009-03-18 15:10:06.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdflib/p_defopt.h	2009-06-08 17:57:28.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_defopt.h,v 1.165.2.17 2009/02/27 17:01:02 kurt Exp $
+/* $Id: p_defopt.h,v 1.165.2.18 2009/06/08 11:27:51 kurt Exp $
  *
  * PDFlib shared option definitions and structures
  *
@@ -233,6 +233,9 @@
     {"skipposttable", pdc_booleanlist, PDF_SKIPPOSTTABLE_FLAG, 1, 1, \
       0.0, 0.0, NULL}, \
 \
+    {"dropcorewidths", pdc_booleanlist, PDC_OPT_NONE, 1, 1, \
+      0.0, 0.0, NULL}, \
+\
     {"keepnative", pdc_booleanlist, PDF_KEEPNATIVE_FLAG, 1, 1, \
       0.0, 0.0, NULL}, \
 \
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdflib/pdflib.h PDFlib-Lite-7.0.4/libs/pdflib/pdflib.h
--- PDFlib-Lite-7.0.4.bak/libs/pdflib/pdflib.h	2009-03-18 15:10:07.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdflib/pdflib.h	2009-06-08 17:57:30.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: pdflib.h,v 1.293.2.46 2009/03/16 14:52:03 rjs Exp $
+/* $Id: pdflib.h,v 1.293.2.50 2009/06/08 15:36:40 rjs Exp $
  *
  * Public function declarations for PDFlib Lite, PDFlib, PDFlib+PDI, and PPS;
  * see PDFlib API reference for details.
@@ -38,7 +38,7 @@
 #define PDFLIB_MAJORVERSION	7		/* major version number */
 #define PDFLIB_MINORVERSION	0       	/* minor version number */
 #define PDFLIB_REVISION		4       	/* revision number */
-#define PDFLIB_VERSIONSTRING	"7.0.4"       /* The whole bunch */
+#define PDFLIB_VERSIONSTRING	"7.0.4p4"       /* The whole bunch */
 
 
 /*
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdflib/pdflib.rc PDFlib-Lite-7.0.4/libs/pdflib/pdflib.rc
--- PDFlib-Lite-7.0.4.bak/libs/pdflib/pdflib.rc	2009-03-18 15:10:03.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdflib/pdflib.rc	2009-06-08 17:57:26.000000000 +0200
@@ -28,8 +28,8 @@
 //
 
 VS_VERSION_INFO VERSIONINFO
- FILEVERSION 7,0,4,02
- PRODUCTVERSION 7,0,4,02
+ FILEVERSION 7,0,4,42
+ PRODUCTVERSION 7,0,4,42
  FILEFLAGSMASK 0x3fL
 #ifdef _DEBUG
  FILEFLAGS 0x1L
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdflib/p_document.c PDFlib-Lite-7.0.4/libs/pdflib/p_document.c
--- PDFlib-Lite-7.0.4.bak/libs/pdflib/p_document.c	2009-03-18 15:10:06.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdflib/p_document.c	2009-06-08 17:57:28.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_document.c,v 1.174.2.53 2009/03/16 14:01:12 kurt Exp $
+/* $Id: p_document.c,v 1.174.2.56 2009/05/25 13:54:30 kurt Exp $
  *
  * PDFlib document related routines
  *
@@ -235,7 +235,7 @@
     {"pdfx", pdc_keywordlist, PDF_ICC_FLAG, 1, 1, \
       0.0, 0.0, pdf_pdfx_keylist}, \
 \
-    {"compatibility", pdc_keywordlist, PDC_OPT_IGNOREIF1, 1, 1, \
+    {"compatibility", pdc_keywordlist, PDC_OPT_NONE, 1, 1, \
       0.0, 0.0, pdf_compatibility_keylist}, \
 \
     {"flush", pdc_keywordlist, PDC_OPT_NONE, 1, 1, \
@@ -1267,23 +1267,6 @@
     pdf_get_document_common_options(p, resopts, PDF_FC_BEGIN_DOCUMENT);
 
 
-    /* deprecated */
-    p->bookmark_dest = pdf_init_destination(p);
-
-    pdf_init_images(p);
-    pdf_init_xobjects(p);
-    pdf_init_fonts(p);
-    pdf_init_outlines(p);
-    pdf_init_annot_params(p);
-    pdf_init_colorspaces(p);
-    pdf_init_pattern(p);
-    pdf_init_shadings(p);
-    pdf_init_extgstates(p);
-
-
-
-
-
     /* create document digest */
     pdc_init_digest(p->out);
 
@@ -1330,22 +1313,54 @@
 #endif
 
 
-    if (!pdc_init_output((void *) p, p->out, doc->compatibility, &oc))
+    PDC_TRY(p->pdc)
     {
-        if (oc.filename && *oc.filename)
+        if (!pdc_init_output((void *) p, p->out, doc->compatibility, &oc))
         {
-            pdc_set_fopen_errmsg(p->pdc,
-                pdc_get_fopen_errnum(p->pdc, PDC_E_IO_WROPEN), "PDF ",
-                pdc_errprintf(p->pdc, "%.*s", PDC_ERR_MAXSTRLEN, oc.filename));
+            if (oc.filename && *oc.filename)
+            {
+                pdc_set_fopen_errmsg(p->pdc,
+                    pdc_get_fopen_errnum(p->pdc, PDC_E_IO_WROPEN), "PDF ",
+                    pdc_errprintf(p->pdc, "%.*s", PDC_ERR_MAXSTRLEN,
+                                  oc.filename));
+                if (verbose)
+                {
+                    pdf_cleanup_document_internal(p);
+                    PDC_RETHROW(p->pdc);
+                }
+            }
 
-            if (verbose)
-                PDC_RETHROW(p->pdc);
+            pdf_cleanup_document_internal(p);
+            PDC_EXIT_TRY(p->pdc);
+            return -1;
         }
-
+    }
+    PDC_CATCH(p->pdc)
+    {
         pdf_cleanup_document_internal(p);
+        if (verbose)
+            PDC_RETHROW(p->pdc);
+
         return -1;
     }
 
+    /* deprecated */
+    p->bookmark_dest = pdf_init_destination(p);
+
+    pdf_init_images(p);
+    pdf_init_xobjects(p);
+    pdf_init_fonts(p);
+    pdf_init_outlines(p);
+    pdf_init_annot_params(p);
+    pdf_init_colorspaces(p);
+    pdf_init_pattern(p);
+    pdf_init_shadings(p);
+    pdf_init_extgstates(p);
+
+
+
+
+
     /* Write the constant /ProcSet array once at the beginning */
     p->procset_id = pdc_begin_obj(p->out, PDC_NEW_ID);
     pdc_puts(p->out, "[/PDF/ImageB/ImageC/ImageI/Text]\n");
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdflib/p_font.c PDFlib-Lite-7.0.4/libs/pdflib/p_font.c
--- PDFlib-Lite-7.0.4.bak/libs/pdflib/p_font.c	2009-03-18 15:10:06.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdflib/p_font.c	2009-06-08 17:57:28.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_font.c,v 1.461.2.72 2009/02/20 15:43:32 kurt Exp $
+/* $Id: p_font.c,v 1.461.2.75 2009/06/08 11:23:17 kurt Exp $
  *
  * PDFlib font handling routines
  *
@@ -830,6 +830,7 @@
     fo->xheight = 0;
     fo->linegap = 0;
     fo->auxiliary = pdc_false;
+    fo->dropcorewidths = pdc_false;
 
 }
 
@@ -925,6 +926,8 @@
     if (pdc_get_optvalues("linegap", resopts, &fo->linegap, NULL))
         fo->mask |= (1L << fo_linegap);
 
+
+        pdc_get_optvalues("dropcorewidths", resopts, &fo->dropcorewidths, NULL);
 }
 
 int
@@ -1324,6 +1327,14 @@
     retval = pdc_false;
     while (1)
     {
+        if (font->opt.auxiliary)
+        {
+            /* only in-core fonts are possible */
+            retval = pdf_get_metrics_core(p, font, fontname_p, "", enc,
+                                          pdc_false);
+            break;
+        }
+
 #ifdef PDF_TRUETYPE_SUPPORTED
         /* Check specified TrueType file */
         filename = pdc_find_resource(p->pdc, "FontOutline", fontname_p);
@@ -1399,8 +1410,8 @@
         retval = pdc_false;
 
         /* Searching for a metric file */
-    if (logg1)
-        pdc_logg(p->pdc, "\tSearching for font metrics data file:\n");
+        if (logg1)
+            pdc_logg(p->pdc, "\tSearching for font metrics data file:\n");
 
         filename = testfilename;
         for (i = 0; i < 100; i++)
@@ -1996,7 +2007,7 @@
                 pdc_objref(p->out, "/FontDescriptor", fontdescriptor_id);
 
                 /* bug #1036 */
-                if (font->ft.isstdfont == pdc_true)
+                if (font->ft.isstdfont == pdc_true && font->opt.dropcorewidths)
                     break;
             }
 
@@ -2537,7 +2548,6 @@
 pdf_write_page_fonts(PDF *p)
 {
     int i, total = 0;
-    int bias = p->curr_ppt->fn_bias;
 
     /* This doesn't really belong here, but all modules which write
      * font resources also need this, so we include it here.
@@ -2552,7 +2562,7 @@
         if (p->fonts[i].used_on_current_page == pdc_true)
             total++;
 
-    if (total > 0 || bias)
+    if (total > 0)
     {
         pdc_puts(p->out, "/Font");
         pdc_begin_dict(p->out);         /* font resource dict */
@@ -2564,12 +2574,11 @@
 	{
             if (p->fonts[i].used_on_current_page == pdc_true) {
                 p->fonts[i].used_on_current_page = pdc_false;   /* reset */
-                pdc_printf(p->out, "/F%d", bias + i);
+                pdc_printf(p->out, "/F%d", i);
                 pdc_objref(p->out, "", p->fonts[i].obj_id);
             }
 	}
 
-	if (!bias)
 	    pdc_end_dict(p->out);	/* font resource dict */
     }
 }
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdflib/p_font.h PDFlib-Lite-7.0.4/libs/pdflib/p_font.h
--- PDFlib-Lite-7.0.4.bak/libs/pdflib/p_font.h	2009-03-18 15:10:06.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdflib/p_font.h	2009-06-08 17:57:28.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_font.h,v 1.141.2.9 2008/06/30 15:34:36 kurt Exp $
+/* $Id: p_font.h,v 1.141.2.10 2009/06/08 11:23:17 kurt Exp $
  *
  * Header file for the PDFlib font subsystem
  *
@@ -65,6 +65,7 @@
     int xheight;
     int linegap;
     pdc_bool auxiliary;
+    pdc_bool dropcorewidths;
 };
 
 /* Type3 font structures */
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdflib/p_generr.h PDFlib-Lite-7.0.4/libs/pdflib/p_generr.h
--- PDFlib-Lite-7.0.4.bak/libs/pdflib/p_generr.h	2009-03-18 15:10:06.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdflib/p_generr.h	2009-06-08 17:57:28.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_generr.h,v 1.338.2.55 2009/02/20 15:43:32 kurt Exp $
+/* $Id: p_generr.h,v 1.338.2.56 2009/05/25 09:31:16 tm Exp $
  *
  * PDFlib error messages
  *
@@ -287,6 +287,8 @@
 
 gen(2, 2400, IMAGE_CORRUPT, "Corrupt $1 image file '$2'")
 
+gen(4, 2401, IMAGE_TOO_LARGE, "$1 image '$2' too large ($3 x $4)")
+
 gen(3, 2402, IMAGE_NOPAGE, "Requested page $1 in $2 image '$3' not found")
 
 gen(2, 2404, IMAGE_BADDEPTH,
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdflib/p_hyper.c PDFlib-Lite-7.0.4/libs/pdflib/p_hyper.c
--- PDFlib-Lite-7.0.4.bak/libs/pdflib/p_hyper.c	2009-03-18 15:10:06.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdflib/p_hyper.c	2009-06-08 17:57:29.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_hyper.c,v 1.191.2.29 2008/12/01 10:30:16 kurt Exp $
+/* $Id: p_hyper.c,v 1.191.2.30 2009/04/17 10:46:43 kurt Exp $
  *
  * PDFlib routines for hypertext stuff:
  * named destination, bookmarks, document info
@@ -1341,8 +1341,6 @@
         pdc_error(p->pdc, PDC_E_ILLARG_EMPTY, "key", 0, 0, 0);
 
     len = pdc_check_text_length(p->pdc, &value, len, PDF_MAXSTRINGSIZE);
-    if (!len)
-        pdc_error(p->pdc, PDC_E_ILLARG_EMPTY, "value", 0, 0, 0);
 
     for (kp = forbidden_keys;
         kp != sizeof(forbidden_keys) / sizeof(char *) + forbidden_keys;
@@ -1359,7 +1357,7 @@
 
     /* convert text string */
     val_buf = pdf_convert_hypertext_depr(p, value, len);
-    if (!val_buf)
+    if (val_buf == NULL)
         pdc_error(p->pdc, PDC_E_ILLARG_EMPTY, "value", 0, 0, 0);
 
     /* special handling required for "Trapped" */
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdflib/p_image.h PDFlib-Lite-7.0.4/libs/pdflib/p_image.h
--- PDFlib-Lite-7.0.4.bak/libs/pdflib/p_image.h	2009-03-18 15:10:06.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdflib/p_image.h	2009-06-08 17:57:29.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_image.h,v 1.97.2.8 2008/03/05 22:45:44 myi Exp $
+/* $Id: p_image.h,v 1.97.2.11 2009/05/19 08:32:29 rjs Exp $
  *
  * Header file for the PDFlib image subsystem
  *
@@ -252,6 +252,7 @@
     pdf_ref_type        reference;      /* kind of image data reference */
     pdc_bool            topdown_save;   /* saved topdown flag */
     char               *iconname;       /* icon name for template images */
+    pdf_transgroup      tgroup;         /* transparency group definition */
     /**************************************************************************/
 
     pdc_bool		transparent;	/* image is transparent */
